<?php
// CAPACITY PLANNING REPORT
//
// Copyright (c) 211 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: capacityplanning.php 1020 2012-02-09 23:05:55Z egalstad $

require_once(dirname(__FILE__).'/../componenthelper.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

route_request();

if (!function_exists('json_decode')) {
    function json_decode($json) {
      $comment = false;
      $out     = '$x=';
      for ($i=0; $i<strlen($json); $i++) {
        if (!$comment) {
          if (($json[$i] == '{') || ($json[$i] == '[')) {
            $out .= 'array(';
          }
          elseif (($json[$i] == '}') || ($json[$i] == ']')) {
            $out .= ')';
          }
          elseif ($json[$i] == ':') {
            $out .= '=>';
          }
          elseif ($json[$i] == ',') {
            $out .= ',';
          }
          elseif ($json[$i] == '"') {
            $out .= '"';
          }
          /*elseif (!preg_match('/\s/', $json[$i])) {
            return null;
          }*/
        }
        else $out .= $json[$i] == '$' ? '\$' : $json[$i];
        if ($json[$i] == '"' && $json[($i-1)] != '\\') $comment = !$comment;
      }
      eval($out. ';');
      return $x;
    }
  }

if (!function_exists('json_encode')) {
    function json_encode($data) {
        switch ($type = gettype($data)) {
            case 'NULL':
                return 'null';
            case 'boolean':
                return ($data ? 'true' : 'false');
            case 'integer':
            case 'double':
            case 'float':
                return $data;
            case 'string':
                return '"' . addslashes($data) . '"';
            case 'object':
                $data = get_object_vars($data);
            case 'array':
                $output_index_count = 0;
                $output_indexed = array();
                $output_associative = array();
                foreach ($data as $key => $value) {
                    $output_indexed[] = json_encode($value);
                    $output_associative[] = json_encode($key) . ':' . json_encode($value);
                    if ($output_index_count !== NULL && $output_index_count++ !== $key) {
                        $output_index_count = NULL;
                    }
                }
                if ($output_index_count !== NULL) {
                    return '[' . implode(',', $output_indexed) . ']';
                } else {
                    return '{' . implode(',', $output_associative) . '}';
                }
            default:
                return ''; // Not supported
        }
    }
}

function route_request(){
    global $request;
    
    /*
    if(is_admin()==false){
        echo "You are not authorized to view this report";
        exit();
        }
    */
    $mode       = grab_request_var("mode","");
    $timeframes = grab_request_var("timeframe","");
    $runscript  = grab_request_var("runscript","");
    
    switch($mode){
        case "servicerequest":
            // If mode was 'servicerequest', return the contents div for the
            // service select box.
            $host = htmlentities(grab_request_var('hostname',''));
            display_service_select($host);
            die;
            break;
        case "timeframerequest":
            // If mode was 'timeframerequest', return the contents for the available
            // timeframes. We also need to the hostname and servicename passed to us
            // as well
            $hostname   = grab_request_var("hostname","");
            $service    = grab_request_var("service","");
            if( $hostname && $service )
                display_timeframe_select( $hostname , $service );
            die;
            break;
        case "generateresults":
            // Grab all of the variables that are meaningful and passed to us
            $host                       = grab_request_var("hostname","");
            $service                    = grab_request_var("service","");
            $rangeperiod                = grab_request_var("period","");
            $method                     = grab_request_var("method","");
            $extrapolate                = grab_request_var("extrapolate","");
            $type                       = grab_request_var("return","");
            $dates                      = grab_request_var("dates","");
            $values                     = grab_request_var("values","");
            if(! (strpos($rangeperiod,'|') === false) )
                list( $period , $range )    = explode('|',$rangeperiod);
            else {
                $period = "";
                $range  = "";
            }
            if($dates) {
                if(! (strpos($dates,',') === false) ) { 
                    $datearray = explode(',',$dates);
                    foreach($datearray as $date)
                        $newdate[] = strtotime($date);
                }
                else
                    $newdate[] = strtotime($dates);
                $dates = implode(',',$newdate);
            }
            get_report_data( $host , $service , $period , $range , $method , $extrapolate , $type , $dates , $values );
            die;
            break;
        case "generatehighcharts":
            // Grab all of the variables that are meaningful and passed to us
            $host                       = grab_request_var("hostname","");
            $service                    = grab_request_var("service","");
            $rangeperiod                = grab_request_var("period","");
            $method                     = grab_request_var("method","");
            $extrapolate                = grab_request_var("extrapolate","");
            $type                       = grab_request_var("return","");
            $dates                      = grab_request_var("dates","");
            $values                     = grab_request_var("values","");
            if(! (strpos($rangeperiod,'|') === false) )
                list( $period , $range )    = explode('|',$rangeperiod);
            else {
                $period = "";
                $range  = "";
            }
            if($dates) {
                if(! (strpos($dates,',') === false) ) { 
                    $datearray = explode(',',$dates);
                    foreach($datearray as $date)
                        $newdate[] = strtotime($date);
                }
                else
                    $newdate[] = strtotime($dates);
                $dates = implode(',',$newdate);
            }
            get_highcharts_data( $host , $service , $period , $range , $method , $extrapolate , $type , $dates , $values );
            die;
            break;
        case "getdata":
            get_report_data();
            break;
        case "debug":
            print "hello";
            die;
            break;
        default:
            display_page_header();
            // Display selection boxes for the host or service
            // When the user selects the host or service and submits it
            // it will query the capacity planning Python script for acceptable
            // times frames, which we store in the $time_frame variable.

            display_navigation_tabs();
            display_host_services();
            display_extrapolation_div();
            display_value_div();
            display_date_div();          
			print '<div id="graphtablediv">';
            display_normal_graph();
            display_results_div();
            print '</div>';
			display_results_div();
            display_page_end();
            break;
        }
    }

///////////////////////////////////////////////////////////////////
// FRONTEND GENERATION FUNCTIONS
///////////////////////////////////////////////////////////////////

/*
 * display_page_header()
 * 
 * Just display the header that will be on every single page.
 * 
 * @author - Nicholas Scott
 * 
 */

function display_page_header() {
    
    $baseurl = get_base_url();
    $title = gettext("Capacity Planning");
    
    do_page_start(array("page_title"=>$title),true);
    
    //print "<html>";
    //print "<head>";
    //do_page_head_links();
    print "<script type='text/javascript'>var THISURL = '{$baseurl}';</script>";
    print "<link href='./includes/capacityplanning.css' rel='stylesheet' type='text/css' />";
    print "<script src='./includes/timepicker.js'></script>";
    print "<script type='text/javascript' src='./includes/capacityplanning.js'></script>";
    //print "<script type='text/javascript' src='{$baseurl}/includes/components/highcharts/js/highcharts.js'></script>";     
    //print "<script type='text/javascript' src='{$baseurl}/includes/components/highcharts/js/themes/gray.js'></script>";
    //print "<script type='text/javascript' src='{$baseurl}/includes/components/highcharts/js/modules/exporting.js'></script>";
    //print "</head>";
    //print "<body>";
    
    print "<h1>Capacity Planning</h1>";
    //print "<br/>";
    
    // Enterprise Edition message
    echo enterprise_message(); 
    
    print "<div id='capacityPlanningBody'>";
    print "<form name='capacityPlanning' method='POST' action='".htmlentities($_SERVER["REQUEST_URI"])."'>";
    
}


/*
 * display_page_end()
 * 
 * Wrapper function for do_page_end, just wrapping up the divs and forms that were opened.
 * 
 * @author - Nicholas Scott
 * 
 */
function display_page_end() {
    
    print "</form> <!-- Closes name = 'capacityPlanning' -->";
    print "</div> <!-- Closes id = 'capacityPlanningBody' -->";
    do_page_end(true);
    //print "</body>";
    //print "</html>";

}

function display_navigation_tabs() {
    
    echo "
    <div id='tabs'>
        <ul class='tabnavigation'>
            <li><a href='#tab-hostservice'>".gettext("Hosts and Services")."</a></li>
            <li><a href='#tab-extrapoptions'>".gettext("Extrapolation Options")."</a></li>
            <li><a href='#tab-dates'>".gettext("Date Values")."</a></li>
            <li><a href='#tab-values'>".gettext("Expected Values")."</a></li>
        </ul>
    <div style='clear:both;'></div>
	";
}

function display_host_services() {
    
    // See if 'hostnameselect' variable is set
    $hostset    = grab_request_var('hostnameselect',''); 
    // Get a list of hosts that we could conceivably graph
    $hosts      = get_capacity_planning_host_names();
    // Create a new div to hold the hosts and services
    print "<div id='tab-hostservice' class='ui-tabs-hide cap-height'>";
    print "<div class='statusdetail_panelspacer'></div>";
    print "<div class='reportoptionpicker' style='width:100%'>";
    print "<div class='sectionTitle'>".gettext('Host and Service Selection')."</div>";
    print "<div class='help'>".gettext("Select the host and its corresponding service you want to analyze past data of.")."</div><br />";
    print "<span id='hostList' class='spacedSpan'>";
    
    // Create the dropdown for all the hosts, assign it a JS to load the
    // services menu on change of the select box
    print "<label class='spacedLabel' for='hostnameselect'>".gettext("Host")."</label>";
    print "<select id='hostnameselect' name='hostnameselect' onchange='javascript:hostChange();'>";
    print "<option disabled='disabled'>-- ".gettext("Hosts")." --</option>";
    $selectThis = true;
    foreach($hosts as $index => $hostname) {
        // For each item in the $hosts variable, put it in the option list
        // and check for selected based on the passed REQUEST variables
        $selected = ($selectThis) ? 'selected' : '';
        print "<option value='{$hostname}' {$selected}>{$hostname}</option>";
        $selectThis = false;
        $selectedHost = $hostname;
    }
    
    print "</select>";
    
    print "</span> <!-- Closes 'hostList' span -->";
    print "<span id='serviceList'>";
    display_service_select($hostname);
    print "</span> <!-- Closes 'serviceList' div, to be load via AJAX -->";
    print "</div> <!-- Closes 'reportoptionpicker' div -->";
    print "</div> <!-- Closes tab-hostservice div -->";
    
}

function display_normal_graph() {
    
    //~ print "<div class='reportoptionpicker' style='width:100%'>";
    //~ print "<br />";
    print "<div id='normalGraph'></div><br /><br />";
    //~ print "</div>";

    
}

function display_service_select($host) {
    // Grab services for selected host
    $services = get_capacity_planning_service_names($host);
    
    // Draw select box for these services
    print "<label class='spacedLabel' for='servicenameselect'>".gettext("Service")."</label>";
    echo <<<TOKEN
<select id='servicenameselect' name='servicenameselect' onchange='javascript:serviceChange();' >
TOKEN;
    if($host) {
        $selectThis = true;
        print "<option disabled='disabled'>-- Services --</option>";
        foreach($services as $index => $servicename) {
            if(capacity_planning_data_exists($host,$servicename)) {
                //$selected = ($selectThis) ? 'selected' : '';
                print "<option value='{$servicename}'>{$servicename}</option>";
                $selectThis = false;
            }
            else
                print "<option disabled>{$servicename} - ".gettext("No Perfdata")."</option>";
            }
    }
    print "</select>";
}
    
function display_extrapolation_div() {
    
    print "<div id='tab-extrapoptions' class='ui-tabs-hide cap-height'>";
    print "<div class='statusdetail_panelspacer'></div>";
    print "<div id='extrapoptions' class='reportoptionpicker'>";
    print "<div class='sectionTitle'>".gettext("Extrapolation Options")." ";
    print "</div>";
    
    print "<div class='help'>".gettext("Select a period for the data. The larger period you select the more accurate the forecast will be.")."<br /><br />";
    print gettext("For the most accurate analysis, select Holt-Winters. For general trend analysis select Least Squares. If you're expecting exponential growth select Quadratic or Cubic Fit.")."<br /><br />";
    print gettext("Extrapolate out dictates how far out the algorithm will exrapolate out. It will use the Period selection to extrapolate out that many periods.")."</div><br />";
    
    print "<span id='timeframeList' class='spacedSpan'>";
    display_timeframe_select('' , '');
    print "</span> <!-- Closes 'timeframelist' span -->";
    
    print "<span id='methodList' class='spacedSpan'>";
    display_method_select();
    print "</span> <!-- Closes 'methodList' span -->";
    
    print "<span id='extrapolationList' class='spacedSpan'>";
    display_extrap_select();
    print "</span> <!-- Closes 'extrapolationList' -->";
    print "</div>";
    print "</div>";
}

function display_value_div() {
    
    print "<div id='tab-values' class='ui-tabs-hide cap-height'>";
    print "<div class='sectionTitle'>".gettext("Values")."</div>";
    print "<div class='help'>".gettext("Enter value of the metric you want the analysis to find. For instance, if you want to see what dates some metric will have a value of '40', add a new value and enter 40. Units entered should be the value that the metric is.")."</div><br />";
    
    print "<span id='valueList' class='spacedSpan'>";
    print "<input type='button' value='".gettext("Add Another Value")."' onclick='addValue();' /><br />";
    print "</span> <!-- Closes 'valueList' -->";
    
    print "</div>";
}

function display_date_div() {
    
    print "<div id='tab-dates' class='ui-tabs-hide cap-height'>";
    
    print "<div class='sectionTitle'>".gettext("Dates")."</div>";
    print "<div class='help'>".gettext("Enter dates you wish to see the value of the data.")."</div><br />";
    print "<span id='dateList' class='spacedSpan'>";
    print "<input type='button' value='".gettext("Add Another Date")."' onclick='addDate();' /><br />";
    print "</span> <!-- Closes 'dateList' -->";
    
    print "</div>";
    print "<input type='button' value='".gettext("Calculate")."' onClick='doResultSubmit();' />";
    print "</div>";
    
}

function display_extrap_select() {
    
    print "<label class='spacedLabel' for='extrapselect'>".gettext("Extrapolate Out").":</label>";
    print "<select id='extrapselect' name='extrapselect'>";
    foreach(range(1,4) as $extrap_value)
        print "<option value='{$extrap_value}'>{$extrap_value} ".gettext("Week(s)")."</option>";
    print "</select>";
    
}

function display_timeframe_select($hostname,$service) {
    
    print "<label class='spacedLabel' for='timeframselect'>".gettext("Period").":</label>";
    
    // Print the start of the select box, note that it is not closed here
    print "<select id='timeframeselect' onchange='loadExtrap();' name='timeframeselect' style='visibility:inherit' ";
    
    // If $fetch contain is true, then actually run the script and get time frames for
    // the RRD given in $fetch, otherwise just make a dummy select
    if($hostname && $service) {
        
        $hostname       = str_replace(" ","_",$hostname);
        $service    = str_replace(" ","_",$service);
        $timeframe_array = get_capacity_planning_timeperiod_options($hostname , $service);
        // This is a bit messy, but if the timeframe array comes back as failed
        // it will disable the select box and put in an option saying what the error was.
        if($timeframe_array == 'None') {
            print "disabled='disabled' >";
            print "<option>".gettext("Not Enough Data")."</option>";
        }
        else if($timeframe_array == 'DNE') {
            print "disabled='disabled' >";
            print "<option>".gettext("RRD Does Not Exist")."</option>";
        }
        // If there were no errors, draw the select box 
        else {
            // Closes the select box from above
            print ">";
            foreach($timeframe_array as $period) {
                $weekval = explode('w',$period);
                $weekval = $weekval[0];
                if($weekval > 4 and !enterprise_features_enabled() ) {
                    $disabled = 'disabled';
                    $msg      = gettext(' - Enterprise Feature');
                }
                else {
                    $disabled = '';
                    $msg      = '';
                }
                // Grab first character of Period
                // Make the nice name out of the period
                $nicename  = "{$weekval} Weeks";
                // Make a piggybacked value using | as the delimiter. The first value
                // is the period value and second value will be the range value
                $range      = ($weekval * 2)."w";
                $value      = "{$weekval},w|-{$range}";
                print "<option value='{$value}' $disabled>{$nicename}{$msg}</option>";
            }
        }
    }
    else
        print ">";
    print "</select>";
    
}

function display_method_select() {
    
    print "<label class='spacedLabel' for='methodselect'>".gettext('Method').":</label>";
    
    print "<select id='methodselect' name='methodselect'>";
    
    $methods = get_capacity_planning_methods();
    
    foreach($methods as $shortName => $niceName)
        print "<option value='{$shortName}'>{$niceName}</option>";
    
    print "</select>";
    
}

function display_results_div() {
    
    print "<div id='results'>";
    print "<div id='capacitytable'></div>";
    print "</div> <!-- Closes class 'reportoptionpicker' -->";
    
}
    
///////////////////////////////////////////////////////////////////
// REPORT GENERATION FUCNTIONS
///////////////////////////////////////////////////////////////////

function get_highcharts_data( $host , $service = '_HOST_' , $period , $range , $method , $extrapolate , $type , $dates , $values ){
    //~ Get our base command string
    $cmd="/usr/local/nagiosxi/html/includes/components/capacityplanning/capacityPlanning.py -H ".escapeshellarg($host)." -S ".escapeshellarg($service);
    //~ Make it return JSON
    $cmd.=" -j";
    //~ If we're are graphing, we need a range of dates to graph
    if($range!="")
        $cmd.=" -r ".escapeshellarg($range)."";  // use range only if producing a graph
    //~ If a period is specified, pass it to the command line
    if($period!="")
        $cmd.=" -p ".escapeshellarg($period)."";
    //~ If the extrpolate makes sense, and it exists, we use it
    if(is_numeric($extrapolate)&&$extrapolate!="")
        $cmd.=" -e ".escapeshellarg($extrapolate);
    if($method!="")
        $cmd.=" -z ".escapeshellarg($method)."";
    $cmd.=" -y 0";
    if($dates!=""&&$type=="xml")
        $cmd.=" -d ".escapeshellarg($dates)."";
    if($values!=""&&$type=="xml")
        $cmd.=" -v ".escapeshellarg($values)."";
    ob_start();
    passthru($cmd,$bool);
    $json = ob_get_contents();
    ob_end_clean();
    print generate_highcharts_cp_template( $json , "$service on $host" , $cmd);
}

function get_xml_file( $host , $service ) {
    $pattern = '/[: ]/';
    $host = preg_replace($pattern,'_',$host);
    $service = preg_replace($pattern,'_',$service);
    $xmlDoc = "/usr/local/nagios/share/perfdata/$host/$service.xml";
    $xmlDat = simplexml_load_file($xmlDoc);
    return $xmlDat;
}    

function get_report_data( $host , $service = '_HOST_' , $period , $range , $method , $extrapolate , $type , $dates , $values ){
    
    putenv("MPLCONFIGDIR=/tmp");
    
    $cmd="/usr/local/nagiosxi/html/includes/components/capacityplanning/capacityPlanning.py -H ".escapeshellarg($host)." -S ".escapeshellarg($service);
    if($type=="xml")
        $cmd.=" -x";
    else
        $cmd.=" -g";
    if($range!="")
        $cmd.=" -r ".escapeshellarg($range)."";  // use range only if producing a graph
    if($period!="")
        $cmd.=" -p ".escapeshellarg($period)."";
    if(is_numeric($extrapolate)&&$extrapolate!="")
        $cmd.=" -e ".escapeshellarg($extrapolate);
    if($method!="")
        $cmd.=" -z ".escapeshellarg($method)."";
    if($dates!=""&&$type=="xml")
        $cmd.=" -d ".escapeshellarg($dates)."";
    if($values!=""&&$type=="xml")
        $cmd.=" -v ".escapeshellarg($values)."";    
    if($type=='xml') {
        ob_start();
        passthru($cmd);
        $content_grabbed=ob_get_contents();
        ob_end_clean();
        $dict = simplexml_load_string($content_grabbed);
        print "<div id='tableholder'>";
        print "<table class='tablesorter' id='resulttable'>";
        print "<thead>";
        print " <tr>";
        print "     <th class='sort-header value'>".gettext("Projected Value")."</th>";        
        print "     <th class='sort-header info'>".gettext("Description")."</th>";        
        print "     <th class='sort-header date'>".gettext("Date Reached")."</th>";
        print " </tr>";
        print "<tbody>";
        $column = false;
        if (!$dict->answer)
            print "<tr><td colspan='3'>".gettext("No Dates Specified")."</td></tr>";
        else {
            foreach($dict->answer as $answer) {
                $row_class  = ( $column ) ? 'even' : 'odd';
                $column = !$column;
                $date = $answer['date'];
                if ($date != 'Out of Period')
                    $date = date('M d Y - H:i:s',(int)$date);
                print "<tr class='{$row_class}'>";
                print " <td>{$answer}</td>";        
                print " <td>{$answer['info']}</td>";
                print " <td>{$date}</td>";
                print "</tr>";
            }
        }
        print "</table>";
        print "</div>";
        return;
    }
    
    }

// this function displays report in HTML
function display_report(){
    global $lstr;
    global $request;
    do_page_end(true);
    }

function capacity_planning_data_exists($hostname="",$servicename="_HOST_"){
    return perfdata_chart_exists($hostname,$servicename);
    }
    
function get_capacity_planning_host_names(){

    $hosts=array();

    $args=array('brevity' => 1,
				'orderby' => 'host_name:a',
				); 
    $oxml=get_xml_host_objects($args);
    if($oxml){
        foreach($oxml->host as $hostobject){
            $name=strval($hostobject->host_name);
            $hosts[]=$name;
            }
        }
        
    return $hosts;
    }
    
function get_capacity_planning_service_names($hostname){

    $services=array();

    $args=array(
        'brevity' => 1,
        'host_name' => $hostname,
		'orderby' => 'name:a',
        ); 
    $oxml=get_xml_service_objects($args);
    if($oxml){
        $services[] = '_HOST_';
        foreach($oxml->service as $svcobject){
            $name=strval($svcobject->service_description);
            $services[]=$name;
            }
        }
        
    return $services;
    }
    
function get_capacity_planning_timeperiod_options($hostname , $servicename){
    
	$hostname = escapeshellcmd($hostname);
	$servicename = escapeshellcmd($servicename); 
	
    $shellex    = exec("/usr/local/nagiosxi/html/includes/components/capacityplanning/timeframe.py $hostname $servicename");
    
    // If the return value of the script was None, then there are no viable
    // time frames to extrapolate off of
    if( $shellex == 'None' || $shellex == 'DNE' )
        return $shellex;
    // Otherwise return the split array based off of the commas
    else
        return explode(',',$shellex);
        
    }
    
function get_capacity_planning_methods(){
    
    $opts=array(
        "hw"    => "Holt-Winters",
        "lstsq" => "Least Squares",
        "dpf"   => "Quadratic Fit",
        "tpf"   => "Cubic Fit",
        //"lm" => "Levenburg-Marquardt", // Disabled until implemented
        );
    return $opts;
    }

function add_capacity_planning_data_url_opts(){
    $urlopts="";
    
    $method=grab_request_var("method","");
    $timeperiod=grab_request_var("timeperiod",""); // this is a different period than passed to data backend...
    
    
    // find pre-determined options for this timeperiod
    $topts=get_capacity_planning_timeperiod_options();
    $popts=grab_array_var($topts,$timeperiod,array());
    
    $range=grab_array_var($popts,"range","");
    $period=grab_array_var($popts,"period","");
    $extrapolate=grab_array_var($popts,"extrapolate","");
    $dates=grab_array_var($popts,"dates","");
    
    // add pre-determined options to url
    if($range!="")
        $urlopts.="&range=".urlencode($range);
    if($period!="")
        $urlopts.="&period=".urlencode($period);
    if($extrapolate!="")
        $urlopts.="&extrapolate=".urlencode($extrapolate);
    if($dates!="")
        $urlopts.="&dates=".urlencode($dates);

    // user can specify algorithm/method
    $urlopts.="&method=".urlencode($method);

    
    return $urlopts;
    }

function generate_highcharts_cp_template($graph_data, $title, $cmd) {
    $json = array();
    if (!preg_match('#[0-9]#',$graph_data)) {
        $json["subtitle"] = array(   "text" => $graph_data,
                                            "verticalAlign" => "middle",
                                            "align" => "center",
                                            "style" => array( "fontSize" => "13pt",
                                                                "font" => "Helvetica",
                                                                "fontWeight" => "bold"),
                            );
        $graph_data = '[]';
    }

    $json["chart"] = array(  "renderTo" => "capacityplanningrenderdiv",
                                    "zoomType" => "x",
                                    "spacingRight" => 20,
                                    "height" => 300,
                                    "width" => 800 );
    $json["title"] = array( "text" => $title );
    $json["xAxis"] = array( "type" => "datetime",
                                   "maxZoom" => 300000,
                                   "title" => array( "text" => null ),
                                   );
    $json["yAxis"] = array( "title" => array( "text" => "" ),
                                   "min" => 0,
                                   "startOnTick" => false,
                                   "showFirstLabel" => false, );
    $json["tooltip"] = array( "shared" => true );
    $json["legend"] = array( "enabled" => true );
    $json["plotOptions"] = array( "series" => array( "fillOpacity" => 0.5 ),
                                          "area" => array( "lineWidth" => 1,
                                                            "marker" => array( "enabled" => false,
                                                                                 "states" => array( "hover" => array( "enabled" => true,
                                                                                                                         "radius" => 5 
                                                                                                                        )
                                                                                                    )
                                                                                ),
                                                            "shadow" => false,
                                                            "states" => array( "hover" => array( "lineWidth" => 1,
                                                                                                   )
                                                                               ),
                                                            ),
                                        );
    $json["series"] = json_decode($graph_data);
    $raw_json = json_encode($json);
    $graph = <<<GRAPH
    <div id='capacityplanningrenderdiv'></div>
    <script>
    $(document).ready(function() {
            //reset default colors 
    
    //data points added below for correct datatype interpretation               
    var chart;
        chart = new Highcharts.Chart(
        $raw_json
        );             
    });
    </script>
GRAPH;

    return $graph;
}
?>
